<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<!-- Initialize Bootstrap 4 -->
<link rel="stylesheet" href="https://cdn.staticfile.org/twitter-bootstrap/4.3.1/css/bootstrap.min.css">
<script src="https://cdn.staticfile.org/jquery/3.2.1/jquery.min.js"></script>
<script src="https://cdn.staticfile.org/popper.js/1.15.0/umd/popper.min.js"></script>
<script src="https://cdn.staticfile.org/twitter-bootstrap/4.3.1/js/bootstrap.min.js"></script>
<link rel="stylesheet" type="text/css" href="css/global.css">
<link rel="stylesheet" href="https://jqueryvalidation.org/files/demo/site-demos.css">
<script src="getTokenFromCookie.js"></script>
<script src="parseJwt.js"></script>
<title>Profil</title>
</head>
<body>
	<ul class="nav justify-content-end">
		<li class="nav-item">
			<button type="button" id="bouton-fichiers" class="btn btn-light" style="border: 0.5px solid lightgray;">Accueil</button>
		</li>
	</ul>
	</br>
	
    <div class="profile">
        <div class="header">
            <svg class="bi bi-person-square" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                <path fill-rule="evenodd" d="M14 1H2a1 1 0 00-1 1v12a1 1 0 001 1h12a1 1 0 001-1V2a1 1 0 00-1-1zM2 0a2 2 0 00-2 2v12a2 2 0 002 2h12a2 2 0 002-2V2a2 2 0 00-2-2H2z" clip-rule="evenodd"/>
                <path fill-rule="evenodd" d="M2 15v-1c0-1 1-4 6-4s6 3 6 4v1H2zm6-6a3 3 0 100-6 3 3 0 000 6z" clip-rule="evenodd"/>
            </svg>
            <h1 id="username"></h1>
        </div>

        <div class="table table-borderless">
            <table>
                <tr>
                    <td>First name</td>
                    <td id="firstname"></td>
                </tr>
                <tr>
                    <td>Last name</td>
                    <td id="lastname"></td>
                </tr>
                <tr>
                    <td>Email</td>
                    <td id="email"></td>
                </tr>
                <tr>
                    <td>Year</td>
                    <td id="year"></td>
                </tr>
                <tr>
                    <td>Roles</td>
                    <td id="roles"></td>
                </tr>
            </table>
        </div>
        <button class="btn btn-outline-success" data-toggle="modal" data-target="#modifPwdModal">Modifier mon mot de passe</button><br>
        <button class="btn btn-outline-success" data-toggle="modal" data-target="#modifProfModal">Modifier mon profil</button><br>
        <button class="btn btn-outline-success" id="logout">Log out</button>
    </div>

    <div class="modal fade" id="modifPwdModal">
        <div class="modal-dialog">
          <div class="modal-content">
       
            <div class="modal-header">
              <h4 class="modal-title">Modifier mon mot de passe</h4>
              <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
       
            <div class="modal-body">
                <form id="pwd">
                    <div class="form-group">
                      <label for="pwd">Ancien mot de passe:</label>
                      <input type="password" class="form-control" id="pwd_old" name="pwd_old">
                    </div>
                    <div class="form-group">
                        <label for="pwd_new">Nouveau mot de passe:</label>
                        <input type="password" class="form-control" id="pwd_new" name="pwd_new">
                    </div>
                    <div class="form-group">
                        <label for="pwd_again">Confirmer le nouveau mot de passe:</label>
                        <input type="password" class="form-control" id="pwd_again" name="pwd_again">
                    </div>
                </form>
            </div>

            <div class="modal-footer">
                <button type="submit" class="btn btn-primary" id="modifPwd">Submit</button>
            </div>
        </div>
       
        </div>
    </div>

    <div class="modal fade" id="modifProfModal">
        <div class="modal-dialog">
          <div class="modal-content">
       
            <div class="modal-header">
              <h4 class="modal-title">Modifier mon profil</h4>
              <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
       
            <div class="modal-body">
                <table>
                    <tr>
                        <td>First name</td>
                        <td><input type="text" class="form-control" id="newfirstname"></td>
                    </tr>
                    <tr>
                        <td>Last name</td>
                        <td><input type="text" class="form-control" id="newlastname"></td>
                    </tr>
                    <tr>
                        <td>E-mail</td>
                        <td><input type="text" class="form-control" id="newemail"></td>
                    </tr>
                </table>
                
            </div>

            <div class="modal-footer">
                <button type="submit" class="btn btn-primary" id="modifProf">Submit</button>
            </div>
        </div>
       
        </div>
    </div>
</div>
     
<script src="https://code.jquery.com/jquery-1.11.1.min.js"></script>
<script src="https://jqueryvalidation.org/files/dist/jquery.validate.min.js"></script>
<script src="https://jqueryvalidation.org/files/dist/additional-methods.min.js"></script>
<script>
    var username

    jQuery.validator.setDefaults({
      debug: true,
      success: "valid"
    });
    $( "#pwd" ).validate({
      rules: {
        pwd_again: {
          equalTo: "#pwd_new"
        }
      }
    });

    $("#logout").click(function(e){
        document.cookie = "token=;expires=Thu, 01 Jan 1970 00:00:01 GMT";
        window.location.href = "login.html"; 
    });

    $("#modifPwd").click(function(e){
        reqUrl = "http://localhost:8000/api/user/"+username;
        let pwd_old = $("#pwd_old").val();
        let pwd_new = $("#pwd_new").val();
        let pwd_again = $("#pwd_again").val();
        if(pwd_old != null & pwd_new != null & pwd_new == pwd_again){
            reqUrl += "?oldpassword="+pwd_old+"&newpassword="+pwd_new
        }
        $.ajax({
                type: "POST",
                headers:{"Authorization":"Bearer "+getTokenFromCookie()},
                url: reqUrl,
                success: (data) => {
                    console.log("Password changed")
                    location.reload()                
                },
                error: (err) => {
                    console.log("Error message user addition ：" + JSON.stringify(err))
                    alert(err.statusText);
                }
            })
    });

    $("#modifProf").click(function(e){
        reqUrl = "http://localhost:8000/api/user/"+username+"?";
        let firstname = $("#newfirstname").val();
        if(firstname)
            reqUrl = reqUrl+"&firstname="+firstname;
        let lastname = $("#newlastname").val();
        if(lastname)
            reqUrl = reqUrl+"&lastname="+lastname;
        let email = $("#newemail").val();
        if(email)
            reqUrl = reqUrl+"&email="+email;
        if(firstname == null & lastname ==null & email == null)
            return


        $.ajax({
                type: "POST",
                headers:{"Authorization":"Bearer "+getTokenFromCookie()},
                url: reqUrl,
                success: (data) => {
                    console.log("Profile updated")
                    location.reload()                
                },
                error: (err) => {
                    console.log("Error message user addition ：" + JSON.stringify(err))
                    alert(err.statusText);
                }
            })

    });

    $(document).ready(function(){
		$('#bouton-fichiers').on('click', function () {
			window.location.href= "fichiers.html";
		});
	
        let token = parseJwt(getTokenFromCookie());
        username = token.username
        console.log("username : "+username);
        $("#username").append(username);
        console.log(getTokenFromCookie());
        
        $.ajax({
            type: "GET",
            async: true,
            headers:{"Authorization":"Bearer "+getTokenFromCookie()},
            url: "http://localhost:8000/api/user/"+username,
            success: (data) => {
                var jsonData = JSON.parse(data);
                console.log(jsonData)
                $("#year").append(jsonData.year)
                $("#email").append(jsonData.email)
                $("#firstname").append(jsonData.firstname)
                $("#lastname").append(jsonData.lastname)
                let roles ="";
                $.each(jsonData.roles, function() {
                    if(roles.length != 0){
                        roles += ', ';
                    }
                    roles += this.toString();
                })
                $("#roles").append(roles)

            },
            error: (err) => {
                console.log("Error message load：" + JSON.stringify(err))
                alert(err.statusText);
            }
        })
    })
</script>

</body>
</html>
